#include <stdio.h>
#include <stdlib.h>

struct rebro
{
	int a,b;
	int w;
};

const int MAXN = 512;
const int MAXM = MAXN*MAXN;

int brt;
int n,m;
rebro rebra[MAXM];
int comp[MAXN];
int sum;
int list[MAXN];
int brl;

int cmp(const void* e1, const void* e2)
{
	return ((rebro*)e1)->w - ((rebro*)e2)->w;
}

int getComp(int vert)
{
	brl = 0;

	while(vert!=comp[vert])
	{
		list[brl++] = vert;
		vert = comp[vert];
	}

	while(brl>=0)
	{
		list[brl--] = vert;
	}

	return vert;
}

int main()
{
	//freopen("towns.inp","r",stdin);
	//freopen("towns.out","w",stdout);

	int i;

	scanf("%d",&brt);

	while(brt--)
	{
		scanf("%d %d",&n,&m);

		sum = 0;

		for(i=0;i<m;i++)
		{
			scanf("%d %d %d",&rebra[i].a,&rebra[i].b,&rebra[i].w);
			sum += rebra[i].w;
		}

		qsort(rebra,m,sizeof(rebro),cmp);

		for(i=0;i<MAXN;i++)
			comp[i] = i;

		for(i=0;i<m;i++)
		{
			int c1 = getComp(rebra[i].a);
			int c2 = getComp(rebra[i].b);

			if(c1!=c2)
			{
				sum -= rebra[i].w;
				comp[c1] = c2;
			}
		}

		printf("%d\n",sum);
	}

	return 0;
}
